"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createZoomListComponent = createZoomListComponent;
exports.createZoomListWithReanimatedComponent = createZoomListWithReanimatedComponent;

var _react = _interopRequireWildcard(require("react"));

var _reactNativeGestureHandler = require("react-native-gesture-handler");

var _reactNativeReanimated = require("react-native-reanimated");

var _zoomListContext = require("./zoom-list-context");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function createZoomListComponent(ScrollComponent) {
  const ListComponent = /*#__PURE__*/(0, _react.forwardRef)((props, ref) => {
    const [scrollEnabled, setScrollEnabled] = (0, _react.useState)(true);
    const listRef = (0, _react.useRef)(_reactNativeGestureHandler.Gesture.Native());
    const contextValues = (0, _react.useMemo)(() => ({
      onZoomBegin: () => setScrollEnabled(false),
      onZoomEnd: () => setScrollEnabled(true),
      simultaneousPanGestureRef: listRef.current
    }), []);
    return /*#__PURE__*/_react.default.createElement(_zoomListContext.ZoomListContext.Provider, {
      value: contextValues
    }, /*#__PURE__*/_react.default.createElement(_reactNativeGestureHandler.GestureDetector, {
      gesture: listRef.current
    }, /*#__PURE__*/_react.default.createElement(ScrollComponent, _extends({}, props, {
      scrollEnabled: scrollEnabled,
      ref: ref
    }))));
  });
  return ListComponent;
}

function createZoomListWithReanimatedComponent(ScrollComponent) {
  const ListComponent = /*#__PURE__*/(0, _react.forwardRef)((props, ref) => {
    const scrollEnabled = (0, _reactNativeReanimated.useSharedValue)(true);
    const listRef = (0, _react.useRef)(_reactNativeGestureHandler.Gesture.Native());
    const contextValues = (0, _react.useMemo)(() => ({
      onZoomBegin: () => {
        scrollEnabled.value = false;
      },
      onZoomEnd: () => {
        scrollEnabled.value = true;
      },
      simultaneousPanGestureRef: listRef.current
    }), [scrollEnabled]);
    const animatedProps = (0, _reactNativeReanimated.useAnimatedProps)(() => {
      return {
        scrollEnabled: scrollEnabled.value
      };
    });
    return /*#__PURE__*/_react.default.createElement(_zoomListContext.ZoomListContext.Provider, {
      value: contextValues
    }, /*#__PURE__*/_react.default.createElement(_reactNativeGestureHandler.GestureDetector, {
      gesture: listRef.current
    }, /*#__PURE__*/_react.default.createElement(ScrollComponent, _extends({}, props, {
      animatedProps: animatedProps,
      ref: ref
    }))));
  });
  return ListComponent;
}
//# sourceMappingURL=createZoomListComponent.js.map